// $Id: ball.h 6991 2010-12-02 04:10:59Z suzuki $
// -*-: coding:utf-8; -*-
# ifndef _bullet_H_
# define _bullet_H_

# include <stdlib.h>
# include <gtk/gtk.h>
# include <glib/gprintf.h>
# include <gtk_lib.h>

# include <anime.h>
# include <event.h>

# define KINDS_OF_BULLETS 6

// スプライト
typedef struct { 
	myAnimeArea *anime_area; // のっかっているアニメーション領域
	gint timeout;            // スプライトのタイムアウト */
	GdkPixbuf *pixbuf;       // スプライト用画像（ピクスバッファ）
	gint width;              // 幅
	gint height;             // 高さ
	gint x, y, dx, dy;       // 座標・ベクトル
	GSourceFunc move;        // 動きを決める関数

	/* 追加要素 */
	int bullet_type;         // 種類
	int speed;               // 速度
	int damage;              // 敵へのダメージ
} bulletSprite;

typedef struct {
	char *pics;
	int speed;
	int damage;
} bulletType;

extern gint g_bullet_num;
// extern bulletSprite *bullet[100];
extern GList *bullet;
extern bulletType bullet_type[KINDS_OF_BULLETS];

//void bullets_init(myAnimeArea *area, gint nballs);
//mySprite *ball_new(myAnimeArea *area);
void bullet_new(myAnimeArea *area,gint x,gint y,gint dx,gint dy,gint type);
void bullet_init(bulletSprite *sprite, gint x, gint y, gint dx, gint dy);
void bullet_move(bulletSprite *sprite);
gint bullet_collision(bulletSprite *self);
void bullet_remove(bulletSprite *self);
gint bullet_is_clicked(gpointer area);

//アニメーション領域 API
myAnimeArea *
bullet_anime_area_new(gint width, gint height, GdkPixmap *bg_pixmap, gint timeout);
// 幅，高さ，背景画像，時間間隔 (ms) を指定して，
// アニメーション領域を作る

void
bullet_anime_area_remove(myAnimeArea *area);
//アニメーション領域 area を消す

// スプライトAPI
bulletSprite *
bullet_sprite_new(myAnimeArea *area, gchar *path, gint timeout, GSourceFunc, GSourceFunc);
//スプライトを作成する
// area: 作成されるスプライトがのる，アニメーション領域
// path: 画像ファイルへのパス
// timeout: スプライトを動かす時間間隔，
//       描画はアニメーション領域の再描画時に行う

void bullet_sprite_init(bulletSprite *sprite);
// スプライトの位置とベクトルの初期値を決める関数
// 利用者が用意する

void bullet_sprite_move(bulletSprite *sprite);
// スプライトを移動する関数
// 利用者が用意する

void bullet_sprite_remove(bulletSprite *);
// スプライトの消去
# endif 
