// $Id: ball.h 6991 2010-12-02 04:10:59Z suzuki $
// -*-: coding:utf-8; -*-
# ifndef _ENEMY_H_
# define _ENEMY_H_

# include <stdlib.h>
# include <gtk/gtk.h>
# include <glib/gprintf.h>
# include <gtk_lib.h>

# include <anime.h>
# include <event.h>

# define KINDS_OF_ENEMYS 6

// スプライト
typedef struct { 
	myAnimeArea *anime_area; // のっかっているアニメーション領域
	gint timeout;            // スプライトのタイムアウト */
	GdkPixbuf *pixbuf;       // スプライト用画像（ピクスバッファ）
	gint width;              // 幅
	gint height;             // 高さ
	gint x, y, dx, dy;       // 座標・ベクトル
	GSourceFunc move;        // 動きを決める関数

	int life;
	int reward;
	int damage;

  int id; /* 追加 */
} enemySprite;

typedef struct {
	char *pics;
	int reward;
	int speed;
	int life;
	int damage;
} enemyType;

extern gint g_enemy_num;
extern gint g_enemy_type;
extern GList *enemy;
extern enemyType enemy_type[KINDS_OF_ENEMYS];
extern gint g_enemy_call_max;
extern gint g_enemy_call_count;
extern gint g_enemy_group_max;
extern gint g_enemy_group_count;
extern gint g_enemy_id;

void enemys_init(myAnimeArea *area, gint nballs);
void enemy_new(myAnimeArea *area);
void enemy_init(enemySprite *sprite);
void enemy_move(enemySprite *sprite);
gint enemy_collision(enemySprite *self);
void enemy_remove(enemySprite *self);
void enemy_read_data(char *filedata);

//アニメーション領域 API
myAnimeArea *
enemy_anime_area_new(gint width, gint height, GdkPixmap *bg_pixmap, gint timeout);
// 幅，高さ，背景画像，時間間隔 (ms) を指定して，
// アニメーション領域を作る

void
enemy_anime_area_remove(myAnimeArea *area);
//アニメーション領域 area を消す

// スプライトAPI
enemySprite *
enemy_sprite_new(myAnimeArea *area, gchar *path, gint timeout, GSourceFunc, GSourceFunc);
//スプライトを作成する
// area: 作成されるスプライトがのる，アニメーション領域
// path: 画像ファイルへのパス
// timeout: スプライトを動かす時間間隔，
//       描画はアニメーション領域の再描画時に行う

void enemy_sprite_init(enemySprite *sprite);
// スプライトの位置とベクトルの初期値を決める関数
// 利用者が用意する

void enemy_sprite_move(enemySprite *sprite);
// スプライトを移動する関数
// 利用者が用意する

void enemy_sprite_remove(enemySprite *);
// スプライトの消去
# endif 
