# ifndef _MY_EVNET_H_
# define _MY_EVNET_H_

# include <event.h>
# include <anime.h>
# include <gdk/gdkkeysyms.h>

gint cb_motion_notify_event(GtkWidget *widget, GdkEventMotion *event,gpointer *data);
gint cb_button_press_event(GtkWidget *widget, GdkEventButton *event,gpointer *data);
gint cb_button_release_event(GtkWidget *widget, GdkEventButton *event, gpointer *data);
gint cb_key_press_event(GtkWidget *widget, GdkEventKey *event, gpointer *data);
gint cb_key_release_event(GtkWidget *widget, GdkEventKey *event, gpointer *data);

myEvent *
my_event_new(GtkWidget *widget)
{
  myEvent *e = (myEvent *) g_new0(myEvent, 1);

  e->widget = widget;

  e->motion_event = (GdkEventMotion *) NULL;
  e->button_event = (GdkEventButton *) NULL;
  e->key_event = (GdkEventKey *) NULL;

  //e->m_notify = (GSourceFunc *) NULL;
  //e->m_press = (GSourceFunc *) NULL;
  //e->m_release = (GSourceFunc *) NULL;
  //e->k_press = (GSourceFunc *) NULL;
  //e->k_release = (GSourceFunc *) NULL;

  return e;
}

void
my_event_set(myEvent *ev, gpointer data)
{
  myAnimeArea *area = (myAnimeArea *) data;
  ev->self = area;
  if (ev->m_notify!=NULL)
    {
      gtk_widget_add_events(ev->widget, GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK);
      g_signal_connect(G_OBJECT(ev->widget), "motion_notify_event",
		       G_CALLBACK(cb_motion_notify_event), area);
    }
  if (ev->m_press!=NULL)
    {
      // printf("m_press_event is set.\n");
      gtk_widget_add_events(ev->widget, GDK_BUTTON_PRESS_MASK);
      g_signal_connect(G_OBJECT(ev->widget), "button_press_event",
		       G_CALLBACK(cb_button_press_event), area);
    }
  if (ev->m_release!=NULL)
    {
      // printf("m_release_event is set.\n");
      gtk_widget_add_events(ev->widget, GDK_BUTTON_RELEASE_MASK);
      g_signal_connect(G_OBJECT(ev->widget), "button_relese_event", 
		       G_CALLBACK(cb_button_release_event), area);
    }
  if (ev->k_press != NULL)
    {
      //printf("key_press_event is set.\n");
      gtk_widget_add_events(ev->widget, GDK_KEY_PRESS_MASK);
      g_signal_connect(G_OBJECT(ev->widget), "key_press_event",
                   G_CALLBACK(cb_key_press_event), area);
    }
  if (ev->k_release != NULL)
    {
      //printf("key_release_event is set.\n");
      gtk_widget_add_events(ev->widget, GDK_KEY_RELEASE_MASK);
      g_signal_connect(G_OBJECT(ev->widget), "key_release_event",
		       G_CALLBACK(cb_key_release_event), area);
    }
}


gint 
cb_motion_notify_event(GtkWidget *widget, GdkEventMotion *event,
                       gpointer *data)
{
  myAnimeArea *self = (myAnimeArea *) data;
  myEvent *ev = self->event;

  if (ev->m_notify!=NULL) 
    {
      ev->motion_event = event;
      (*ev->m_notify)((gpointer) self);
    }
  return FALSE;
}

gint 
cb_button_press_event(GtkWidget *widget, GdkEventButton *event,
                       gpointer *data)
{
  myAnimeArea *self = (myAnimeArea *) data;
  myEvent *ev = self->event;
  if (ev->m_press!=NULL) 
    {
      ev->button_event = event;
      (*ev->m_press)((gpointer) self);
    }
  return FALSE;
}

gint 
cb_button_release_event(GtkWidget *widget, GdkEventButton *event,
                       gpointer *data)
{
  myAnimeArea *self = (myAnimeArea *) data;
  myEvent *ev = self->event;

  if (ev->m_release!=NULL) 
    {
      ev->button_event = event;
      (*ev->m_release)((gpointer) self);
    }
  return FALSE;
}

gint 
cb_key_press_event(GtkWidget *widget, GdkEventKey *event,
                       gpointer *data)
{
  myAnimeArea *self = (myAnimeArea *) data;
  myEvent *ev = self->event;

  if (ev->k_press!=NULL) 
    {
      ev->key_event = event;
      (*ev->k_press)((gpointer) self);
    }
  return FALSE;
}

gint 
cb_key_release_event(GtkWidget *widget, GdkEventKey *event,
                       gpointer *data)
{
  myAnimeArea *self = (myAnimeArea *) data;
  myEvent *ev = self->event;

  if (ev->k_press!=NULL) 
    {
      ev->key_event = event;
      (*ev->k_press)((gpointer) self);
    }
  return FALSE;
}

# endif
