# ifndef _MY_GTK_LIB_H_
# define _MY_GTK_LIB_H_
# include <gtk/gtk.h>

# define WIDTH 800
# define HEIGHT 600

//gtkの機能をまとめて使うためのインターフェイス

typedef PangoFontDescription My_Font_Desc;

// 初期化
//   とにかく実行直後に呼んでおくこと
void my_init(int argc, char *argv[]);

// ウィンドウの作成
//   600x480, 枠の幅が15pixel
GtkWidget * my_window_new(gint width, gint height);

// ラベルの作成
GtkWidget * my_label_new(char *label, My_Font_Desc *fontdescription); 
// ラベル付きボタンの作成
GtkWidget * my_button_new(char *label, My_Font_Desc *fontdescription); 
// イメージの作成
GtkWidget * my_image_new(char *path);

// Fontset
My_Font_Desc  *my_font_description(const gchar *fontname);

//Pixmap
GdkPixmap *my_pixmap_new_from_data(GtkWidget *window, char *path);

GtkWidget *my_drawing_area_new(int w, int h, GdkPixmap *pixmap, gboolean relative);

int
my_animation(GtkWidget *window, GtkWidget *drawin_area, gboolean (*handler)(gpointer), int timeout);

// イベント処理 (コールバック) 関数

gint my_close_handler(GtkWidget *widget, gpointer gdata);
void my_button_clicked_handler(GtkWidget *widget, gpointer data);
gboolean my_set_click_and_remove(gboolean);
void my_widget_remove(GtkWidget *);

int my_timeout_add(int timeout, GSourceFunc handler, gpointer widget);

# endif

