#include <stdio.h>
#include <stdlib.h>
#include <music.h>

void music_init(void)
{
	SDL_Init(SDL_INIT_AUDIO);

	Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,
				  MIX_DEFAULT_FORMAT, 2, 1024);

	Mix_AllocateChannels(16);
}

void play_bgm(char *filename)
{
	Mix_Music *music;

	music = Mix_LoadMUS(filename);
	if (music == NULL) {
		printf("%s is not found.\n", filename);
		exit(0);
	}

	Mix_PlayMusic(music, -1);
}

void play_se(char *filename)
{
	Mix_Chunk *se;

	se = Mix_LoadWAV(filename);
	if (se == NULL) {
		printf("%s is not found.\n", filename);
		exit(0);
	}

	Mix_PlayChannel(-1, se, 0);
}

void stop_music(void)
{
	Mix_HaltMusic();
}
