#ifndef _SYSTEM_H_
#define _SYSTEM_H_

#include <gtk/gtk.h>
#include <anime.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <string.h>

#define SYSTEM_SCALE 0.5

#define SYSTEM_DEBUG 1
#define SYSTEM_BUFFER_MAX 1024
/* デバッグモード時は1 */

// int stage = 0;
/* maplife money */

typedef struct {
	int wave_number;
	int life;
	int money;
} System;

// スプライト
typedef struct { 
	myAnimeArea *anime_area; // のっかっているアニメーション領域
	gint timeout;            // スプライトのタイムアウト */
	GdkPixbuf *pixbuf;       // スプライト用画像（ピクスバッファ）
	gint width;              // 幅
	gint height;             // 高さ
	gint x, y;       		   // 座標
	GSourceFunc move;        // 動きを決める関数
	gint num;
} systemSprite;

extern System *g_system;
extern GList *system_list;
extern gboolean g_system_delete_life[9];

void systems_init();

void system_save();
/*
   データのセーブをする関数
   引数：なし（仮）
 */
void system_load();
/*
   データをロードする関数
   引数：なし
 */
void system_draw(gint life, gint money, gboolean first, gint type);
/*
   画像の表示を行う関数
   引数：
   ・ライフ，所持金，最初の呼び出しか，表示するもの(ライフ,所持金，両方)
 */
void system_set(int goflag,int cost);
/*
   味方及び敵の配置を行う関数
   引数：
   ・マップの通行許可 int goflag
   ・味方のコスト int cost
 */
void pos_hash(char symbol,int *pos_X,int *pos_Y);


void systems_init(void);
//mySprite *ball_new(myAnimeArea *area);
void system_new(myAnimeArea *area, gint x, gint y, gint num);
void system_init(systemSprite *sprite);
void system_move(systemSprite *sprite);
//gint system_collision(systemSprite *self);
void system_remove(systemSprite *self);
//アニメーション領域 API
myAnimeArea *
system_anime_area_new(gint width, gint height, GdkPixmap *bg_pixmap, gint timeout);
// 幅，高さ，背景画像，時間間隔 (ms) を指定して，
// アニメーション領域を作る

void
system_anime_area_remove(myAnimeArea *area);
//アニメーション領域 area を消す

// スプライトAPI
systemSprite *
system_sprite_new(myAnimeArea *area, gchar *path, gint timeout, GSourceFunc, GSourceFunc, gint, gint);
//スプライトを作成する
// area: 作成されるスプライトがのる，アニメーション領域
// path: 画像ファイルへのパス
// timeout: スプライトを動かす時間間隔，
//       描画はアニメーション領域の再描画時に行う

void system_sprite_init(systemSprite *sprite);
// スプライトの位置とベクトルの初期値を決める関数
// 利用者が用意する

void system_sprite_move(systemSprite *sprite);
// スプライトを移動する関数
// 利用者が用意する

void system_sprite_remove(systemSprite *);
// スプライトの消去

#endif
