// $Id: ball.h 6991 2010-12-02 04:10:59Z suzuki $
// -*-: coding:utf-8; -*-
# ifndef _UNIT_H_
# define _UNIT_H_

# include <stdlib.h>
# include <gtk/gtk.h>
# include <glib/gprintf.h>
# include <gtk_lib.h>

# include <math.h>

# include <enemy.h>
# include <anime.h>
# include <event.h>

# define KINDS_OF_UNITS 6

//# define FIRE_INTERVAL 2000 /* move関数を呼び出す間隔 */


// スプライト
typedef struct { 
  myAnimeArea *anime_area; // のっかっているアニメーション領域
  gint timeout;            // スプライトのタイムアウト */
  GdkPixbuf *pixbuf;       // スプライト用画像（ピクスバッファ）
  gint width;              // 幅
  gint height;             // 高さ
  gint x, y;       		   // 座標
  GSourceFunc move;        // 動きを決める関数

  gint unit_type;
  gint level;
  gint cost;
  gint range;
  gint fire_interval;
  gint bullet_type;
  gint unit_newtype;

} unitSprite;

typedef struct {
  char *pics;
  gint cost;
  gdouble range;
  gint fire_interval;
  gint bullet_type;
  gint unit_newtype;
} unitType;

typedef struct {
  gint x;
  gint y;
} gtk_vector;

//extern gint g_ememy_num;
//extern gint g_mighty_num;
extern GList *unit_list;
extern unitType unit_type[KINDS_OF_UNITS];
extern gint unit_id;

void units_init(void);
//mySprite *ball_new(myAnimeArea *area);
void unit_new(myAnimeArea *area, gint x, gint y, gint type);
void unit_init(unitSprite *sprite);
void unit_move(unitSprite *sprite);
//gint unit_collision(unitSprite *self);
void unit_remove(unitSprite *self);
//gint unit_is_clicked(gpointer area);

//アニメーション領域 API
myAnimeArea *
unit_anime_area_new(gint width, gint height, GdkPixmap *bg_pixmap, gint timeout);
 // 幅，高さ，背景画像，時間間隔 (ms) を指定して，
 // アニメーション領域を作る

void
unit_anime_area_remove(myAnimeArea *area);
 //アニメーション領域 area を消す

// スプライトAPI
unitSprite *
unit_sprite_new(myAnimeArea *area, gchar *path, gint timeout, GSourceFunc, GSourceFunc, gint, gint);
/* gint x, gint y は追加したもの */
 //スプライトを作成する
 // area: 作成されるスプライトがのる，アニメーション領域
 // path: 画像ファイルへのパス
 // timeout: スプライトを動かす時間間隔，
 //       描画はアニメーション領域の再描画時に行う
  
void unit_sprite_init(unitSprite *sprite);
   // スプライトの位置とベクトルの初期値を決める関数
   // 利用者が用意する

void unit_sprite_move(unitSprite *sprite);
 // スプライトを移動する関数
 // 利用者が用意する

void unit_sprite_remove(unitSprite *);
 // スプライトの消去

gtk_vector unit_fire_control(unitSprite *sprite);

gtk_vector unit_simple_aim(unitSprite *sprite, gint dist_x, gint dist_y, gdouble dist);

gtk_vector unit_linear_prediction(gint self_x, gint self_y, enemySprite *e, gint spd);

void unit_delete(gint x, gint y);

void unit_upgrade(myAnimeArea *area, gint x, gint y);

# endif 
